'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _rolesClient = require('roles-client');

var _rolesClient2 = _interopRequireDefault(_rolesClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RoleCheck = function (_Component) {
  _inherits(RoleCheck, _Component);

  function RoleCheck(props, context) {
    _classCallCheck(this, RoleCheck);

    var _this = _possibleConstructorReturn(this, (RoleCheck.__proto__ || Object.getPrototypeOf(RoleCheck)).call(this, props, context));

    _this.state = {
      isLoading: true,
      hasAccess: false
    };
    return _this;
  }

  _createClass(RoleCheck, [{
    key: 'componentDidMount',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var _props, roles, group, hasAccess;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _props = this.props, roles = _props.roles, group = _props.group;
                // TODO Catch and handle promise error

                hasAccess = false;

                if (!(roles && group)) {
                  _context.next = 8;
                  break;
                }

                _context.next = 5;
                return _rolesClient2.default.userIsInRole(roles, group);

              case 5:
                hasAccess = _context.sent;
                _context.next = 12;
                break;

              case 8:
                if (!group) {
                  _context.next = 12;
                  break;
                }

                _context.next = 11;
                return _rolesClient2.default.userIsInGroup(group);

              case 11:
                hasAccess = _context.sent;

              case 12:
                // eslint-disable-next-line react/no-did-mount-set-state
                this.setState({
                  isLoading: false,
                  hasAccess: hasAccess
                });

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentDidMount() {
        return _ref.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'render',
    value: function render() {
      return this.state.hasAccess && this.props.children;
    }
  }]);

  return RoleCheck;
}(_react.Component);

RoleCheck.propTypes = {
  children: _react.PropTypes.node.isRequired,
  roles: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.array]),
  group: _react.PropTypes.string.isRequired
};
exports.default = RoleCheck;